﻿using System;
using System.Linq;
using System.Linq.Expressions;
using System.Collections.Generic;

namespace Achiral.Extension
{
    public static partial class MakeWorld
    {
        public static Func<T1, TResult> Unbind1st<T1, TResult>(this Func<TResult> func, T1 dummy)
        {
            if (func == null) throw new ArgumentNullException("func");

            return func.Method.CreateDelegate<Func<T1, TResult>>();
        }
        public static Func<T1, T2, TResult> Unbind1st<T1, T2, TResult>(this Func<T2, TResult> func, T1 dummy)
        {
            if (func == null) throw new ArgumentNullException("func");

            return func.Method.CreateDelegate<Func<T1, T2, TResult>>();
        }
        public static Func<T1, T2, T3, TResult> Unbind1st<T1, T2, T3, TResult>(this Func<T2, T3, TResult> func, T1 dummy)
        {
            if (func == null) throw new ArgumentNullException("func");

            return func.Method.CreateDelegate<Func<T1, T2, T3, TResult>>();
        }
        public static Func<T1, T2, T3, T4, TResult> Unbind1st<T1, T2, T3, T4, TResult>(this Func<T2, T3, T4, TResult> func, T1 dummy)
        {
            if (func == null) throw new ArgumentNullException("func");

            return func.Method.CreateDelegate<Func<T1, T2, T3, T4, TResult>>();
        }

    }
}