﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Reflection;

namespace Achiral.Extension
{
    public static partial class MakeWorld
    {
        public static TDelegate CreateDelegate<TDelegate>(this MethodInfo method)
            where TDelegate:class
        {
            return Delegate.CreateDelegate(typeof(TDelegate), method) as TDelegate;
        }
        public static TDelegate CreateDelegate<TReceiver, TDelegate>(this MethodInfo method, TReceiver reciever)
            where TDelegate : class
        {
            return Delegate.CreateDelegate(typeof(TDelegate), reciever, method) as TDelegate;
        }
        public static Func<TResult> CreateFunc<TResult>(this MethodInfo method)
        {
            return method.CreateDelegate<Func<TResult>>();
        }
        public static Func<T1, TResult> CreateFunc<T1, TResult>(this MethodInfo method)
        {
            return method.CreateDelegate<Func<T1, TResult>>();
        }
        public static Func<T1, T2, TResult> CreateFunc<T1, T2, TResult>(this MethodInfo method)
        {
            return method.CreateDelegate<Func<T1, T2, TResult>>();
        }
        public static Func<T1, T2, T3, TResult> CreateFunc<T1, T2, T3, TResult>(this MethodInfo method)
        {
            return method.CreateDelegate<Func<T1, T2, T3, TResult>>();
        }
        public static Func<T1, T2, T3, T4, TResult> CreateFunc<T1, T2, T3, T4, TResult>(this MethodInfo method)
        {
            return method.CreateDelegate<Func<T1, T2, T3, T4, TResult>>();
        }
    }
}